<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
<!ENTITY ssvg-specification-03 SYSTEM "references/reference.ssvg-specification-03.xml">
<!ENTITY en-smm-apc-web-guidelines-01 SYSTEM "references/reference.en-smm-apc-web-guidelines-01.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='info' number="2413734" consensus='false' ipr='trust200902' docName='dashboard-project-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title Dashboard Project
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    author(fullname='Mathieu Donzé' initials='M.D.')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email mathieu.donze@cern.ch
    date(year='2020' month="April" day="28")

    keyword dashboard

    abstract
      t This document presents the EN-SMM-APC Dashboard Project.

  middle

    section
      name Introduction
      t
        | This document describes the EN-SMM-APC Dashboard Project.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section(anchor='Overview')
      name Overview

      t
        | The goal if this project is to provide and easy and convenient tool
        | for non-developers (as well as developers) to implement graphical
        | dashboards that reflect a system (as in device, machine ...) state.

      t Here's a general overview of an EN-SMM-APC Dashboard:
      figure
        name EN-SMM-APC Dashboard Overview
        artwork(align='center' type='binary-art' src='dashboard-project/dashboard-overview.png')

    section(anchor='Requirements')
      name Requirements

      t
        | The Dashboard project #[bcp14 MUST] provide the following features:
      ul
        li live value display from CERN operation devices through dashboard basic (gauge, text ...)
        li limited historical data display
        li graphical system state overview
        li notification features: SMS, mails, icons
        li limited storage

      t
        | It #[bcp14 MAY] provide those features by relying on external services,
        | such as (but not limited to): NXCALS, Grafana, Expert interfaces...

      t
        | What the Dashboard is #[strong not]:
      ul
        li An historical data navigator
        li An operation tool
        li An alarm server
        li A graphing tool

      t
        | The idea underneath this project is to link existing services altogether
        | and display a simple single-page aggregated information, directly linking
        | to external services, such as NXCALS, Grafana, expert-interfaces whenever relevant.

    section
      name End-Users

      t
        | The following end-users have been identified (hopefuly amongst others):
      ul
        li
          | #[strong EN-SMM-MRO]: to test and monitor deployed hardware, creating
          | their own flows and managing their views
        li
          | #[strong BE-ICS-TI]: as a replacement for #[xref(target="TIM") TIM]
          | technology.
        li
          | #[strong EN-STI]: to monitor devices, EN-SMM-MRO being the dashboard
          | editor and maintainer.
        li
          | Experiment such as #[strong n_ToF] and #[strong UA9] as public
          | dashboards.

      section
        name Indirect Users

        t
          | All components are designed to be modular and re-used as much as
          | possible, some of those have already been identified:
        ul
          li
            | #[strong ssvg-engine] and #[strong ssvg-editor] will be directly
            | integrated in other projects to animate SVGs
            | (ex: in #[xref(target="FBI") FBI], #[xref(target="CRYO_Dashboard") CRYO Dashboard] and
            | #[xref(target="NTOF_SDAQ") n_ToF Standalone-DAQ]).
          li
            | #[strong cmw-core.js] and other data-sources will be reused as
            | proxies in other projects.

    section(anchor='Dashboard')
      name Dashboard

      t
        | The #[xref(target='NODE_RED') Node-RED] project has been identified as
        | a robust and stable framework to implement flow-based dashboards.

      t
        | An home-backed version of this tool #[bcp14 SHOULD] be prepared, linked
        | to a custom marketplace providing the following flows:
      ul
        li #[xref(target="D_ELEMENTS") Dashboard elements]
        li #[xref(target="D_STATE_VIEW") System state view]
        li #[xref(target="D_DATA_SOURCES") Data Sources]
        li Mailing service
        li CERN SMS service

      section(anchor="D_ELEMENTS")
        name Dashboard Elements

        t
          | A set of dashboard elements, it #[bcp14 MAY] based on
          | #[xref(target='NODE_RED_DASHBOARD') Node-RED dashboard].

        t
          | The graphing library used #[bcp14 MAY] have to be replaced with
          | #[xref(target="D3_JS") D3.js] or #[xref(target="HIGHCHART_JS") Highcharts.js].

      section(anchor="D_STATE_VIEW")
        name System state view

        t
          | The System or Device state view is achived using embedded
          | #[xref(target='ssvg-specification-03') Stateful SVG documents],
          | implemented in an #[xref(target='SSVG_ENGINE') SSVG Engine] as
          | described in #[xref(target='D_SSVG')].

        t
          | A Node-RED plugin is #[bcp14 REQUIRED] to integrate those documents,
          | it #[bcp14 MAY] be based on #[xref(target="NODE_RED_SVG") Node-RED SVG plugin],
          | but some reworks are foreseen (editor integration, state declaration ...).

        t
          | An #[xref(target="D_SSVG_EDITOR") SSVG Editor] is #[bcp14 REQUIRED]
          | and #[bcp14 MUST] be accessible or directly embedded in the dashboard
          | editor.

      section(anchor="D_DATA_SOURCES")
        name Data Sources

        t
          | A set of CERN centric Data Sources have been identified and #[bcp14 MUST]
          | be implemented:
        ul
          li #[strong RDA3/RBAC] to access BE-CO middleware.
          li #[strong C2MON] to access BE-ICS middleware.
          li #[strong NXCALS/Timber] to retrieve historical data.

        t
          | Those Data Sources #[bcp14 SHOULD] be implemented as:
        ul
          li A general purpose middleware client library
          li A Node-RED plugin that uses the middleware client library

        t Some additional flows #[bcp14 MAY] be added to this list (ex: Siemens S7 flow).

    section(anchor='D_SSVG')
      name Stateful SVG

      t
        | #[xref(target='ssvg-specification-03') Stateful SVG documents] are used
        | to render a graphical view of a given system or device on our dashboards.

      t
        | This #[xref(target='SVG1_1') SVG] extension provides a declarative
        | language to animate SVG documents.

      t
        | An #[xref(target="SSVG_ENGINE") SSVG-Engine] has been implemented and
        | is based on #[xref(target="D3_JS") D3.js], no additional work is foreseen
        | on this engine.

    section(anchor='D_SSVG_EDITOR')
      name Stateful SVG editor

      t
        | #[xref(target='ssvg-specification-03') Stateful SVG documents] are
        | designed as a regular #[xref(target='SVG1_1') SVG] extension,
        | being compatible with all SVG editors (Inkscape ...).

      t
        | Still no editor exist for the "Stateful" extension part, thus
        | an integration work in an existing editor is foreseen, expecting the
        | following features:
      ul
        li basic SVG edition (paths, shapes, transforms ...)
        li group/ungroup feature
        li identification feature (ids, classes ...)
        li available from the dashboard

      t
        | This editor #[bcp14 MUST] be able to modify state, and #[bcp14 SHOULD]
        | be able to animate it.

      t
        | This editor #[bcp14 SHOULD] rely on an existing SVG editor such
        | as #[xref(target="SVG_EDIT") SVG Edit].

    section
      name Infrastructure

      figure
        name EN-SMM-APC Dashboards infrastructure
        artwork(align='center' type='binary-art' src='dashboard-project/dashboard-infrastructure.png')

      section
        name Flow

        t
          | Flow are #[xref(target='DOCKER') Docker] containers that
          | #[bcp14 SHOULD] be based on #[xref(target='NODE_RED') Node-RED] core.

        t
          | This container #[bcp14 MAY] be different from official node version,
          | some core flows #[bcp14 MAY] be removed and additional CERN plugins
          | #[bcp14 SHOULD] be enabled.

        t
          | Two flavors of this container #[bcp14 SHOULD] be prepared:
        ul
          li A #[strong project] oriented version using #[xref(target="NODE_RED_PROJECTS") Node-RED Projects] feature and providing a playground for editors.
          li A #[strong deployed] version with restricted editing capabilities and dedicated to viewers and production environments.

        t
          | Those containers #[bcp14 MUST] be built using gitlab-ci and deployed
          | according to #[xref(target='en-smm-apc-web-guidelines-01') EN-SMM-APC Guidelines].

        section
          name Project Flows

          t
            | Project Flows are playground services for flow editors, it
            | is a #[xref(target='NODE_RED') Node-RED] application where the
            | end-user ("editor") has full access to all the features.

          t
            | The editor can use this service to:
          ul
            li
              | Fetch a flow by connecting to its #[xref(target='CERN_GIT') GitLab]
              | hosted project.
            li Deploy the flow on the playground container
            li Edit and modify the flow nodes
            li
              | Add/remove plugins and flows from the
              | #[xref(target='D_MARKETPLACE') Flow MarketPlace]
            li
              | Push back the flow on the #[xref(target='CERN_GIT') GitLab]
              | hosted project to publish it (see
              | #[xref(target='D_FLOW_DEPLOYED') Deployed Flow]).

          t
            | Both the editing and the viewing part of this service #[bcp14 SHOULD]
            | be protected by strong authentication, the viewing part #[bcp14 MAY]
            | be left public.

        section(anchor='D_FLOW_DEPLOYED')
          name Deployed Flows

          t
            | Deployed Flows are production services that are meant to be public,
            | its flow #[bcp14 MUST] be read-only and the "edition" feature disabled.

          t
            | Those flows are linked to a branch of its associated
            | #[xref(target='CERN_GIT') GitLab] hosted project (likely to be "master"),
            | it #[bcp14 MUST] be re-deployed whenever this branch is modified.

          t
            | The containers used to host those flows #[bcp14 MUST] be designed
            | to work in a redundant environment (to support heavy loads by
            | deploying multiple containers), still the flow #[bcp14 MUST]
            | be developed accordingly.

          t
            | Authentication on those containers is #[bcp14 OPTIONAL], but
            | #[bcp14 MUST] a feature available and configured using
            | #[xref(target='D_FLOW_ADMIN') Flow admin] service.

      section(anchor='D_FLOW_ADMIN')
        name Flow admin

        t
          | Flow admin is a #[xref(target='DOCKER') Docker] container that
          | provides administrative tools to create and manage deployed
          | flows, projects as well as deployed containers.

        t
          | It #[bcp14 SHOULD] be able to grant permissions on flows, to reconfigure
          | proxies.

        t
          | This container #[bcp14 MUST] be built using gitlab-ci and deployed
          | according to #[xref(target='en-smm-apc-web-guidelines-01') EN-SMM-APC Guidelines].

      section
        name Proxies

        t
          | Proxies are #[xref(target='DOCKER') Docker] containers that
          | #[bcp14 SHOULD] be based on #[xref(target='APACHE') Apache] and
          | are configured to properly route packages to the different services.

        t
          | Routing and external access is managed from the #[xref(target='D_FLOW_ADMIN')] interface.

        t
          | Those containers #[bcp14 MUST] be built using gitlab-ci and deployed
          | according to #[xref(target='en-smm-apc-web-guidelines-01') EN-SMM-APC Guidelines].

      section(anchor='D_MARKETPLACE')
        name Flow Marketplace

        t
          | The Flow Marketplace is a location where Flows and plugins can be
          | exchanged.

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;
        | &ssvg-specification-03;
        | &en-smm-apc-web-guidelines-01;

      references
        name URL References
        reference(anchor='NODE_RED' target='https://nodered.org/')
          front
            title Node-RED is a flow-based programming tool
            author
              organization JS Foundation
            date(year='2013')
          annotation #[tt License: Apache 2.0]

        reference(anchor='NODE_RED_DASHBOARD' target='https://flows.nodered.org/node/node-red-dashboard')
          front
            title A set of dashboard nodes for Node-RED
            author
              organization JS Foundation
          annotation #[tt License: Apache 2.0]

        reference(anchor='NODE_RED_SVG' target='https://flows.nodered.org/node/node-red-contrib-ui-svg')
          front
            title A Node-RED widget node to show interactive SVG (vector graphics) in the dashboard
            author(fullname='Bart Butenaers')
          annotation #[tt License: Apache 2.0]

        reference(anchor='NODE_RED_PROJECTS' target='https://nodered.org/docs/user-guide/projects/')
          front
            title Everything you need to create a redistributable Node-RED application
            author
              organization JS Foundation
            date(year='2013')
          annotation #[tt License: Apache 2.0]

        reference(anchor='SVG1_1' target='https://www.w3.org/TR/SVG11')
          front
            title Scalable Vector Graphics (SVG) 1.1 (Second Edition)
            author
              organization W3C
            date(year='2011')

        reference(anchor='D3_JS' target='https://d3js.org/')
          front
            title Data-Driven Documents
            author(fullname='Mike Bostock')
            date(year='2011')
          annotation #[tt License: BSD]

        reference(anchor='HIGHCHART_JS' target='https://www.highcharts.com/products/highcharts')
          front
            title Highcharts makes it easy for developers to set up interactive charts in their web pages.
            author
              organization Highsoft
            date(year='2009')
          annotation #[tt License: Creative Commons (CC) Attribution-NonCommercial licence]

        reference(anchor='SVG_EDIT' target='https://github.com/SVG-Edit/svgedit')
          front
            title SVG-edit is a fast, web-based, JavaScript-driven SVG drawing editor that works in any modern browser.
            author
              organization SVG-edit team
            date(year='2009')
          annotation #[tt License: MIT]

        reference(anchor='DOCKER' target='https://docker.com')
          front
            title Docker provides a way to run applications securely isolated in a container, packaged with all its dependencies and libraries.
            author(fullname='Solomon Hykes' role='editor')
              organization Docker, Inc
            date(year='2013')

        reference(anchor='APACHE' target='https://httpd.apache.org/')
          front
            title The Apache HTTP Server Project is an effort to develop and maintain an open-source HTTP server.
            author
              organization Apache Software Foundation
            date(year='1995')
          annotation #[tt License: Apache 2.0]

      references
        name CERN Projects and Sites
        reference(anchor="TIM" target="http://timweb.cern.ch/tim2/")
          front
            title A highly reliable, scalable and flexible monitoring solution.
            author
              organization CERN (BE-ICS-IT)

        reference(anchor="FBI" target="https://op-webtools.web.cern.ch/fbi/#/")
          front
            title BE-ICS FBI project
            author
              organization CERN (BE-ICS-IT)

        reference(anchor="CRYO_Dashboard" target='http://dashboard.web.cern.ch/LHC/index#CRYO/LHC_Cryo_Status')
          front
            title CRYO Dashboard page
            author
              organization CERN (BE-ICS-IT)

        reference(anchor="NTOF_SDAQ" target="https://ntof-daq.web.cern.ch/standalone")
          front
            title n_ToF Standalone DAQ interface
            author
              organization CERN (EN-SMM-APC)

        reference(anchor='SSVG_ENGINE' target='https://gitlab.cern.ch/apc/common/www/ssvg-engine')
          front
            title Stateful Scalar Vector Graphics engine
            author
              organization CERN (EN-SMM-APC)
            date(year='2020')

        reference(anchor='CERN_GIT' target='http://information-technology.web.cern.ch/services/git-service')
          front
            title This service offers hosting of code repositories for the Git distributed version control system
            author
              organization CERN (IT)

    section
      name Change Log
      t A list of changes

    section
      name Open Issues
      t A list of open issues regarding this document
